/* adc lib meaga8535 */

#include <inttypes.h>
#include <avr/io.h>
#include "adc.h"

uint16_t readADC_10BIT(uint8_t channel) {

  uint8_t i;
  uint16_t result;
  
  ADCSRA = (1<<ADEN) | (1<<ADPS1) | (1<<ADPS2);    // Frequenzvorteiler 
                               // setzen auf 64 (1) und ADC aktivieren (1)

  ADMUX = channel;    // Kanal waehlen
  ADMUX |=  (1<<REFS0); // AVCC als Referenzspannung nutzen 

  /* nach Aktivieren des ADC wird ein "Dummy-Readout" empfohlen, man liest
     also einen Wert und verwirft diesen, um den ADC "warmlaufen zu lassen" */
  ADCSRA |= (1<<ADSC);              // eine ADC-Wandlung 
  while(!(ADCSRA & (1<<ADIF)));     // auf Abschluss der Konvertierung warten (ADIF-bit)
        
  result = 0;

  /* Eigentliche Messung - Mittelwert aus 4 aufeinanderfolgenden Wandlungen */
  for(i=0;i<4;i++)
  {
    ADCSRA |= (1<<ADSC);            // eine Wandlung "single conversion"
    while(!(ADCSRA & (1<<ADIF)));   // auf Abschluss der Konvertierung warten (ADIF-bit)
    
	result += (ADCL + (ADCH<<8));       // mit uint16_t x
	

	//result += ADC;		    // Wandlungsergebnisse aufaddieren
  }

  ADCSRA &= ~(1<<ADEN);             // ADC deaktivieren (2)

  result >>= 2;                     // Summe durch vier teilen = arithm. Mittelwert

  return result;

}
