/* (c) mgiaco  */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>

#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>

#include "lcd.h"
#include "menue.h"
#include "adc.h"


/* Bit setzen */
#define set_bit(var, bit) ((var) |= (1 << (bit)))
/* Bit lschen */
#define clear_bit(var, bit) ((var) &= (unsigned)~(1 << (bit)))

/* Bit abfragen ==> gibts in der neuen Lib */
//#define bit_is_set(var, bit) ((var) & (1 << (bit)))
//#define bit_is_clear(var, bit) !bit_is_set(var, bit)



//void lcd_putsint(int data, char line, char pos);
//void lcd_putsfloat(float data, char line, char pos);

void init(void);


volatile uint16_t ok=0;
volatile uint16_t ok1=0;
volatile uint16_t ok2=0;

volatile uint8_t bool=0;

volatile uint16_t i=0;
volatile uint16_t time=0;



SIGNAL (SIG_OVERFLOW0){
	
	TCNT0 = 0x9c; //100uSEc bei 8MHz und Presceller durch 8!!
	
	
	if(ok == 10000){
		 PORTB = PINB ^ ( 1 << PB0 );  /* .. LED an Port PB0 ein/aus */
		ok = 0;
	}
	
	if(ok2 == 5000){
		if(bool==0){
		   	menue_show();
		}else 
		   //	menue_update();

		ok2 = 0;
	}
	
	if(time==0) bool = 0;	
	
	
	if(ok1 == 2500){
		
		spannung = readADC_10BIT(0);

		//spannung = readADC(0)*(5./1024);	
		//lcd_putsfloat( voltage, 1,1);

		if(DOWN){
			for(i=0;i<255;i++){}
				if(DOWN){
					menue_scroll(1);
					time = 60000;
					bool = 1;
				}
		}

		if(UP){
			for(i=0;i<255;i++){}
				if(UP){
					menue_scroll(0);
					time = 60000;
					bool = 1;
				}
		}

		if(ENTER){
			for(i=0;i<255;i++){}
				if(ENTER){
					subMenue_Enter();
					time = 60000;
					bool = 1;
				}
		}


		ok1 = 0;
	}
	
	
	if(bool) time--;
	
	ok ++;
	ok1 ++;
	ok2 ++;

}


void init(void){

	DDRB  = 0xff;	// PortB als Ausgang,	1111 1111 
    PORTB = 0x00;	// Pull`s  deaktiviert 	0000 0000
	DDRA  = 0x00;		// use all pins on port A for input

	TCCR0 = (1<<CS01);	// count with cpu clock/8
	TIMSK = 1<<TOIE0;	// enable TCNT0 overflow 
 	
 	TCNT0 = 0x9c;	//100uSEc bei 8Mhz
	
	lcd_init(LCD_DISP_ON);
	lcd_home();
	lcd_clrscr();
        
    /* put string to display (line 1) with linefeed */
    //lcd_puts("STRAT:\n");
	
}


int main(void){
	
	init();	
	menue_show();
	sei();

	for(;;);	
}

